package
{
	import flash.utils.getTimer;
	
	import starling.animation.Juggler;
	import starling.core.Starling;
	import starling.display.MovieClip;
	import starling.display.Sprite;
	import starling.events.Event;
	import starling.textures.Texture;
	import starling.textures.TextureAtlas;
	
	public class MonkeySprite extends Sprite
	{
		private var standMovie:MovieClip;
		private var walkLeftMovie:MovieClip;
		private var walkRightMovie:MovieClip;
		private var mouseX:Number = -1;
		private var lastTime:int;
		private var animationState:int;
		private static const STAND_MOVIE:int = 0;
		private static const WALK_LEFT_MOVIE:int = 1;
		private static const WALK_RIGHT_MOVIE:int = 2;
		private var movieVector:Vector.<MovieClip>;
		
		public function MonkeySprite()
		{
			var atlas:TextureAtlas = Assets.getTextureAtlas();

			var standFrames:Vector.<Texture> = atlas.getTextures("monkey_1");
			standMovie = new MovieClip(standFrames, 7 );
			standMovie.loop = true;
			addChild(standMovie);
			animationState = STAND_MOVIE;
		
			var walkLeftFrames:Vector.<Texture> = atlas.getTextures("monkey_walk_left_");
			walkLeftMovie = new MovieClip(walkLeftFrames, 7 );
			walkLeftMovie.loop = true;
			
			var walkRightFrames:Vector.<Texture> = atlas.getTextures("monkey_walk_right_");
			walkRightMovie = new MovieClip(walkRightFrames, 7 );
			walkRightMovie.loop = true;
		
			movieVector = new Vector.<MovieClip>();
			movieVector[STAND_MOVIE] = standMovie;
			movieVector[WALK_LEFT_MOVIE] = walkLeftMovie;
			movieVector[WALK_RIGHT_MOVIE] = walkRightMovie;
				
			pivotX = this.width * 0.5;
			this.addEventListener(Event.ENTER_FRAME, onFrame);
		}		
		
		public function onFrame(e:Event):void
		{
			if(mouseX == -1)
				return;
			
			var newAnimationState:int = -1;				
			
			// snap
			if(this.x <= mouseX+5 && this.x >= mouseX-5)
			{
				this.x = mouseX;
				newAnimationState = STAND_MOVIE;										
			}
			else
			{
				var timeDiff:int = getTimer()-lastTime;
				lastTime += timeDiff;

				if(mouseX > this.x)
				{
					this.x += timeDiff*.15;
					newAnimationState = WALK_RIGHT_MOVIE;					
				}
				else
				{
					this.x -= timeDiff*.15;
					newAnimationState = WALK_LEFT_MOVIE;					
				}				
			}
			
			if(newAnimationState != animationState)
			{
				removeChild(movieVector[animationState]);
				Starling.juggler.remove(movieVector[animationState]);
 				
				animationState = newAnimationState;
				addChild(movieVector[animationState]);
				Starling.juggler.add(movieVector[animationState]);										
			}
		}
		
		public function moveToPoint(pointX:Number):void
		{
			mouseX = pointX;
			lastTime = getTimer();
		}
	}
}